<?php

if ( ! defined( 'ABSPATH' ) ) {
    exit; // Exit if accessed directly
}

class Somalite_Rating_Notice {
    private $past_date;

    public function __construct() {
        $this->past_date = false == get_option('somalite_maybe_later_time') ? strtotime( '-5 days' ) : strtotime('-15 days');

        if ( current_user_can('administrator') ) {
            if ( empty(get_option('somalite_rating_dismiss_notice')) && empty(get_option('somalite_rating_already_rated')) ) {
                add_action( 'admin_init', [$this, 'somalite_check_theme_install_time'] );
            }
        }

        if ( is_admin() ) {
            add_action( 'admin_head', [$this, 'somalite_enqueue_scripts' ] );
        }

        add_action( 'wp_ajax_somalite_rating_dismiss_notice', [$this, 'somalite_rating_dismiss_notice'] );
        add_action( 'wp_ajax_somalite_rating_already_rated', [$this, 'somalite_rating_already_rated'] );
        add_action( 'wp_ajax_somalite_rating_maybe_later', [$this, 'somalite_rating_maybe_later'] );
    }

    public function somalite_check_theme_install_time() {   
        $install_date = get_option('somalite_activation_time');

        if ( false !== $install_date && $this->past_date >= $install_date ) {
            add_action( 'admin_notices', [$this, 'somalite_render_rating_notice' ]);
        }
    }

    public function somalite_rating_maybe_later() {
        update_option('somalite_maybe_later_time', true);
        update_option('somalite_activation_time', strtotime('now'));
    }
    
    public function somalite_rating_dismiss_notice() {
        update_option( 'somalite_rating_dismiss_notice', true );
    }

    function somalite_rating_already_rated() {    
        update_option( 'somalite_rating_already_rated' , true );
    }

    public function somalite_render_rating_notice() {
        if ( is_admin() ) {

            echo '<div class="notice somalite-rating-notice is-dismissible" style="border-left-color: #0073aa!important; display: flex; align-items: center;">
                        <div class="somalite-rating-notice-logo">
                        <img class="somalite-logo" src="'.get_theme_file_uri().'/inc/activation/img/logo-spiracle.png">
                        </div>
                        <div>
                            <h3>Thank you for using Somalite WordPress Theme to build this website!</h3>
                            <p>Could you please do us a BIG favor and give it a 5-star rating on WordPress? Just to help us spread the word and boost our motivation.</p>
                            <p>
                                <a href="https://wordpress.org/support/theme/somalite/reviews/?filter=5" target="_blank" class="somalite-you-deserve-it button button-primary">OK, you deserve it!</a>
                                <a class="somalite-maybe-later"><span class="dashicons dashicons-clock"></span> Maybe Later</a>
                                <a class="somalite-already-rated"><span class="dashicons dashicons-yes"></span> I Already did</a>
                            </p>
                        </div>
                </div>';
        }
    }

    public function somalite_enqueue_scripts() { 
        echo "
        <script>
        jQuery( document ).ready( function() {

            jQuery(document).on( 'click', '.somalite-rating-notice .notice-dismiss', function(e) {
                e.preventDefault();
                jQuery(document).find('.somalite-rating-notice').slideUp();
                jQuery.post({
                    url: ajaxurl,
                    data: {
                        action: 'somalite_rating_dismiss_notice',
                    }
                })
            });

            jQuery(document).on( 'click', '.somalite-maybe-later', function() {
                jQuery(document).find('.somalite-rating-notice').slideUp();
                jQuery.post({
                    url: ajaxurl,
                    data: {
                        action: 'somalite_rating_maybe_later',
                    }
                })
            });
        
            jQuery(document).on( 'click', '.somalite-already-rated', function() {
                jQuery(document).find('.somalite-rating-notice').slideUp();
                jQuery.post({
                    url: ajaxurl,
                    data: {
                        action: 'somalite_rating_already_rated',
                    }
                })
            });
        });
        </script>

        <style>
            .somalite-rating-notice {
              padding: 0 15px;
            }

            .somalite-rating-notice-logo {
                margin-right: 20px;
                width: 100px;
                height: 100px;
            }

            .somalite-rating-notice-logo img {
                max-width: 100%;
            }

            .somalite-rating-notice h3 {
              margin-bottom: 0;
            }

            .somalite-rating-notice p {
              margin-top: 3px;
              margin-bottom: 15px;
            }

            .somalite-already-rated,
            .somalite-maybe-later {
              text-decoration: none;
              margin-left: 12px;
              font-size: 14px;
              cursor: pointer;
            }

            .somalite-already-rated .dashicons,
            .somalite-maybe-later .dashicons {
              vertical-align: sub;
            }

            .somalite-logo {
                height: 100%;
                width: auto;
            }

        </style>
        ";
    }
}

new Somalite_Rating_Notice();